//=============================================================
// Alex A. Trubetskoy, May 2003
//=============================================================
#include "stdafx.h"
#include "CPPNCalc.h"

bool isDigit(char c) {
  if(c>='0' && c<='9')return true;
  return false;
}

//the priopity of the operation
int CPPNCalc::prior(char c) {      
    switch(c) {
        case '(': return 1;
        case '+': case '-': return 2;
        case '*': case '/': return 3;
        default: return 0;
    }
}

//convert to PPN
void CPPNCalc::analyses(CString str) {                     
  int was_op = 0, np = 0;    //if there were operations & brackets  
  iin = 0;                   //index of input string
  str_out.Empty();   
  Stack<char> op_stack;             
  str_in = str;

  if((!isDigit(str_in[0])) && str_in[0]!='(') 
      throw (CString)" ";

  while (nxtc() != EOS_IN) {
    if(isDigit(curc)) {
		mov2strout(curc); 
		was_op = 0; 
		continue;
	}
	else mov2strout(' '); 
    switch (curc) {
      case '(': op_stack.push(curc); np++; was_op = 0; break;
      case '*': case '/': case '+': case '-':
          if(iin == str_in.GetLength())
			  throw (CString)" ";

          if(!was_op) { 
			  was_op = 1;
              while(prior(curc) <= prior(op_stack.top())) {
				  mov2strout(op_stack.pop());
			  }
              if(prior(curc) > prior(op_stack.top())){
				  op_stack.push(curc);
			  }
			  break;
          }
          else throw (CString)" ";

      case ')':
          if(was_op) 
			  throw (CString)" ";
          else 
			  while((curc = op_stack.pop())!= '(' && np>0){
				  mov2strout(curc);
			  } 
			  np--; 
			  break;
      default: {
          throw (CString)"    "; 
      }
    }
  }
  while(op_stack.top() != EOS)
	  mov2strout(op_stack.pop());
  if(np) 
	  throw (CString)"  ";      
} 

//calculate
int CPPNCalc::calc() {
	char* err;
    int n1, n, res = 0, i;
    Stack<int> val_stack;
	CString number;  
	number.Empty();
                                      
    for(i = 0; i<str_out.GetLength(); ++i) {
        if(str_out[i] == ' ')continue;
	    while(i<str_out.GetLength() && isDigit(str_out[i])) {
			   number += str_out[i++];
		}
		if(!number.IsEmpty()) {
		    val_stack.push((int)strtol(number, &err, 10));
			number.Empty();
			if(i >= str_out.GetLength())
			     break;                 //end of the input string
		
			if(str_out[i] == ' ') continue;
		}
        n = val_stack.pop();         //the first current number
		n1 = val_stack.pop();        //the second current number
        switch(str_out[i]) {
           case '+': res = n + n1; break;
           case '-': res = n1 - n; break;
           case '*': res = n * n1; break;
           case '/': res = n1 / n; break;
           default: throw (CString)"";
		}
        val_stack.push(res);
	} 
    return val_stack.pop();
}
